# -*- coding: utf-8 -*-

import sys
import glob
from qpid.messaging import *
import optparse

def countMessages(obj):

	address = 'artix.paygate' if obj == 'payments' or obj == 'paymentstimeout' else 'artix.soldcards'
	countM = 0    	
	broker="localhost:5672"
	connection = Connection(broker)

	try:
		connection.open()
		session = connection.session()
		receiver = session.receiver('%s; {create: always}' % (address))
		while True:
			message = receiver.fetch(0)
			
			if obj == 'paymentstimeout':
				if not (u'status' in message.content and message.content[u'status'] == u'timeout'):
					continue
			
			countM += 1
	except MessagingError,m:
		pass
	finally:
		connection.close()

	return countM

def main(argv):
		
	parser = optparse.OptionParser()
	parser.add_option("-c", "--cards-in-queue", action="store_false", help="sold cards that are in the queue")
	parser.add_option("-p", "--payments-in-queue", action="store_false", help="payments that are in the queue")
	parser.add_option("-m", "--payments-in-queue-with-status-timeout", action="store_false", help="payments that are in the queue with status 'timeout'")
	parser.add_option("-e", "--payments-with-error", action="store_false", help="payments with errors")
	parser.add_option("-t", "--payments-temporary", action="store_false", help="payments into temporary directory")
	(options, args) = parser.parse_args(argv)

	countObjects = 0	
	
	if options.cards_in_queue != None:
		countObjects = countMessages('cards')
	elif options.payments_in_queue != None:
		countObjects = countMessages('payments')
	elif options.payments_in_queue_with_status_timeout != None:
		countObjects = countMessages('paymentstimeout')
	elif options.payments_with_error != None:
		countObjects = len(glob.glob('/linuxcash/cash/data/errorpayment/*.paydata*'))
	elif options.payments_temporary != None:
		countObjects = len(glob.glob('/linuxcash/cash/data/tmp/*.paydata') + glob.glob('/linuxcash/cash/data/tmp/*.paygate'))
	else: 
		parser.print_help()
		exit(1)		

	print countObjects

if __name__ == '__main__':
	main(sys.argv[1:])
