# -*- coding: utf-8 -*-

import os, sys
import optparse

from qpid.messaging import *
import datetime
import json

def createMessage(filename, action):

    with open(filename, 'r') as json_data:
        return json.load(json_data)

def sendMessage(text, broker):

    address = "artix.paygate"
    connection = Connection(broker)
    try:
        connection.open() 
        session = connection.session()
        sender = session.sender('%s; {create: always}' % (address))
        request = Message(durable=True, content=text, id=hex(hash(datetime.datetime.now())))
        sender.send(request)
        print "Message: %s was sent." % text

    except MessagingError,m:
        print m, MessagingError
    finally:
        connection.close()

def main(argv):

    parser = optparse.OptionParser()
    parser.add_option("-f", "--file", help="full file path payment error")
    parser.add_option("-a", "--action", help="the action to the payment. Must be 'commit' or 'rollback'. commit - pay, rollback - cancel payment")
    parser.add_option("-b", "--broker", help="<localhost>:<port>", default = 'localhost:5672')

    (options, args) = parser.parse_args(argv)

    if options.file == None:
        print parser.print_help()
        exit(1)

    if options.action == None:
        print parser.print_help()
        exit(1)

    if not options.action in ['commit', 'rollback']:
        print parser.print_help()
        exit(1)

    if os.path.isfile(options.file):
        message = createMessage(options.file, options.action)
        sendMessage(message, options.broker)
    else:
        print "Error: file '" + options.file +"' does not exists."
        exit(1) 

if __name__ == '__main__':
    main(sys.argv[1:])
    