# -*- coding: utf-8 -*-

import optparse
import sys
from qpid.messaging import MessagingError, Connection, SendError

def logDeleteMess(countDelMess):
    print "Messages deleted: '%s'." % countDelMess

def deleteAllPayment(session, address):

    countRemovePayments = 0
    try:
        receiver = session.receiver('%s; {create: always}' % (address))
        while True:
            receiver.fetch(0)
            countRemovePayments += 1
    except MessagingError:
        pass
    session.acknowledge()

    logDeleteMess(countRemovePayments)

def getMessagesWithoutPaymentId(session, address, paymentid):

    listMess = []
    countRemovePayments = 0
    try:
        receiver = session.receiver('%s; {create: always}' % (address))
        while True:
            msg = receiver.fetch(0)
            if 'paymentId' in msg.content and paymentid == msg.content['paymentId']:
                print "try delete message with paymentid '%s'" % paymentid
                countRemovePayments += 1
                continue
            listMess.append(msg)
    except MessagingError:
        pass
    return [listMess, countRemovePayments]

def deleteMessage(broker, address, paymentid):

    connection = Connection(broker)
    try:
        connection.open()
        session = connection.session()
        if paymentid == 'all':
            deleteAllPayment(session, address)
            return
        listMess, countRemovePayments = getMessagesWithoutPaymentId(session, address, paymentid)
        if not countRemovePayments:
            print "Message with paymentid '%s' not found." % paymentid
            logDeleteMess(countRemovePayments)
            return
        snd = session.sender('%s; {create: always}' % (address))
        for mes in listMess:
            try:
                snd.send(mes)
            except SendError, e:
                print e
                return
        session.acknowledge()
        if snd:
            snd.close()
        logDeleteMess(countRemovePayments)
    except MessagingError, m:
        print m
    finally:
        connection.close()

def main(argv):

    parser = optparse.OptionParser()
    parser.add_option("-b", "--broker", help="<localhost>:<port>", default = 'localhost:5672')
    parser.add_option("-q", "--queue", help="name of queue", default = 'artix.paygate')
    parser.add_option("-p", "--paymentid", help="number id of payment or 'all'")
    (options, args) = parser.parse_args(argv)

    if options.paymentid == None:
        print parser.print_help()
        exit(1)

    deleteMessage(options.broker, options.queue, options.paymentid)

if __name__ == '__main__':
    main(sys.argv[1:])
