# -*- coding: utf8 -*-
'''
Created on 01.02.2012

@author: kov
'''

from artix_discount import ThriftExchangeService
from plugins_base import BasePlugin, Queue, ThriftBinaryClient
from logging import getLogger
from contextlib import closing
import json
import os

logger = getLogger('su.artix.aqspy')
@Queue(name='artix.discount')
class ArtixDiscountPlugin(BasePlugin):
    
    client = ThriftBinaryClient(ThriftExchangeService.Client)
    
    def __init__(self):
        super(ArtixDiscountPlugin, self).__init__()
        
        
    def _tryHosts(self, hosts):
        for addr, port in hosts:
            logger.info(u'Пробуем %s:%s' % (addr, port))
            try:
                self.socket.host = addr
                self.socket.port = int(port)
                with closing(self.socket):
                    self.socket.open()
                    yield self.client
            except Exception, e:
                logger.error(u'Ой: %s' % e)
                continue
        
    def handleMessage(self, message):
        
        ok = False
        
        logger.info("")
        logger.info(u'ARTIXDISCOUNT - Получено сообщение:')
        
        session = json.loads(message.content)
        hosts = [ (session['host'], session[u'port']) ]
        for client in self._tryHosts(hosts):        
        
            request = ThriftExchangeService.TRequest()
            
            request.requestType = int(session["requestType"])            
            request.id = session["id"]            
            request.cashCode = session["cashCode"]    
            request.shift = session["shift"]                    
            request.sCode = session["sCode"]            
            request.rDate = session["rDate"]            
            request.rTime = session["rTime"]            
            request.rTimestamp = session["rTimestamp"]            
            request.checknum = session["checknum"]            
            request.cardNo = session["cardNo"]            
            request.cardType = session["cardType"]            
            request.sum1 = session["sum1"]            
            request.sum2 = session["sum2"]            
            request.sum = session["sum"]    
            request.sumType = session["sumType"]           
            request.discType = session["discType"]            
            request.discAbs = session["discAbs"]            
            request.discPerc = session["discPerc"]            
            request.docNum = session["docNum"]            
            request.errorCode = session["errorCode"]            
            str = session[u'message']
            request.message = str.encode('utf8')            
            request.cDept = session["cDept"]            
            request.vCode = session["vCode"]            
            request.idStr = session["idStr"]            
            request.shopCode = session["shopCode"]            
            request.idName = session["idName"]            
            request.usedBonus = session["usedBonus"]            
            request.positions = []
            idSession = session["idSession"]            
            filePath = session["filePath"]

            logger.info(u'ARTIXDISCOUNT - Формируем подтверждение на дисконт сервер.')
            logger.info("")
            logger.info("requestType ", request.requestType)            
            logger.info("id %s" % request.id)
            logger.info("cashCode %s" % request.cashCode)            
            logger.info("shift %s" % request.shift)
            logger.info("sCode %s" % request.sCode)
            logger.info("rDate %s" % request.rDate)            
            logger.info("rTime %s" % request.rTime)
            logger.info("rTimestamp %s" % request.rTimestamp)
            logger.info("checknum %s" % request.checknum)
            logger.info("cardNo %s" % request.cardNo)
            logger.info("cardType %s" % request.cardType)
            logger.info("sum1 %s" % request.sum1)
            logger.info("sum2 %s" % request.sum2)
            logger.info("sum %s" % request.sum)
            logger.info("sumType %s" % request.sumType)
            logger.info("discType %s" % request.discType)
            logger.info("discAbs %s" % request.discAbs)            
            logger.info("discPerc %s" % request.discPerc)
            logger.info("docNum %s" % request.docNum)
            logger.info("errorCode %s" % request.errorCode)
            logger.info("message %s" % request.message)
            logger.info("cDept %s" % request.cDept)
            logger.info("vCode %s" % request.vCode)
            logger.info("idStr %s" % request.idStr)
            logger.info("shopCode %s" % request.shopCode)            
            logger.info("idName %s" % request.idName)
            logger.info("usedBonus %s" % request.usedBonus)            
            logger.info("idSession %s" % idSession)
            logger.info("filePath %s" % filePath)
            logger.info("")
            
            client.putRequest(request, idSession)

            logger.info(u'ARTIXDISCOUNT - Метод выполнен!')
                   
            
            if (os.path.exists(filePath)):
                os.remove(filePath)
                logger.info(u'ARTIXDISCOUNT - Файл \'%s\' удален.' % filePath)
            logger.info("")
            
            ok = True
            break
        
        if not ok:
            raise Exception(u'Сообщение не обработано: %s' % message.content)
