# -*- coding: utf8 -*-
'''
Created on 13.11.2012

@author: kov
'''

from plugins_base import Queue
from logging import getLogger
import orders_base

queue = 'artix.orders'
logger = getLogger('su.artix.aqspy')
prefixLog = queue.upper()

@Queue(name=queue)
class OrdersPlugin(orders_base.OrdersBasePlugin):
    
    def __init__(self):        
        orders_base.OrdersBasePlugin.__init__(self, prefixLog)
        self.failTimeout = 10        
        
    def handleMessage(self, message):

        try:            
            orders_base.OrdersBasePlugin.handleMessage(self, message)
        except Exception as inst:
            
            logger.error(u'%s: При отправки чека на печать произошла ошибка: %s.%s.' % (prefixLog, type(inst), inst))
            queueBad = orders_base.OrdersBasePlugin.queueNameBad
            logger.error(u'%s: Сообщение будет отправлено в очередь %s' % (prefixLog, queueBad))
            session = self.connection.session()
            sender = session.sender(queueBad)
            sender.send(message)
            logger.error(u'%s: Сообщение отправлено.' % prefixLog)     
        
        

