# -*- coding: utf8 -*-
from plugins_base import BasePlugin, Queue
import datetime
import sys
import os.path
import socket
import marshal
from logging import getLogger
from qpid.messaging import *

logger = getLogger('su.artix.aqspy')
@Queue(name='artix.scales')
class ScalesPlugin(BasePlugin):
    
    def __init__(self):
        super(ScalesPlugin, self).__init__()

    def IntegerToBcd(self,value, size):
    	result = range(size)
    	while (size > 0):
    		result[size-1] = (value / 10 % 10) * 16 + value % 10
    		value = value / 100
    		size = size - 1

    	return result	

        
    def handleMessage(self, message):
		data = message.content['data']
		port = int(message.content['port'])
		host = message.content['host']
		status = message.content['statusfile']
		statusfile = open(status,'w')
		statusfile.write('Download start')	
		statusfile.close()	
		value = marshal.loads(data)
		
		for line in value:		
			statusfile = open(status,'w')	
			statusfile.write('Formating data')
			statusfile.close()	
			logger.debug(u"Metod '%s'." % line["method"])
			if line["method"] == 'clear':
				logger.debug(u"Metod '%s'." % line["method"])
				mess = '\xF2\x25'
			if line["method"] == 'delete':
				mess = '\xF3\x25'
				for val in self.IntegerToBcd(int(line["data"]),4):
					mess = mess + chr(val)
			if line["method"] == 'add':
				mess = '\xF1\x25'
				for val in self.IntegerToBcd(int(line["plu"]),4):						
					mess = mess + chr(val)				
				mess = mess + '\x00\x00'				
				if int(line["measure"]) == 0:
					mess+='\x54' 
				else:
					mess+= '\x55'				
				if int(line["base"]) == 0 :
					mess+='\x00' 
				else:
					mess+= '\x02' 
				mess+= '\x0D\x64\x01' 
				for val in self.IntegerToBcd(int(line["price"]),4):
					mess = mess + chr(val)
				if int(line["base"]) == 0:
					mess += '\x11\x05' 
				else:
					mess += '\x12\x05'
				for val in self.IntegerToBcd(int(line["barcode"][0:6]), 3):
					mess = mess + chr(val)
				for val in self.IntegerToBcd(int(line["barcode"][6:]), 3):
					mess = mess + chr(val)
				if int(line["measure"]) == 0:
					mess += '\x01' 
				else:
					mess += '\x02'
				for val in self.IntegerToBcd(int(line["expiration"]), 2):
					mess = mess + chr(val)
				mess = mess + '\x01'
				firstLine = True			
				for name in line["name"]:
					if not firstLine:
						mess = mess + '\x0D'
					text = name[1].encode('cp866')
					mess = mess + chr(name[0]) + chr(len(text)) + text
					firstLine = False
				mess = mess + '\x0C\x00\x01\x20\x0C\x00'
				mess = mess[0:7] + chr(len(mess) - 2) + mess[8:]
			lengthMess = len(mess)		
			offset = 0	
			
			sock = socket.socket
			sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			statusfile = open(status,'w')			
			statusfile.write('Open connection with scale')
			statusfile.close()	
			sock.connect((host,port))	
			statusfile = open(status,'w')		
			statusfile.write('Send message to scale')
			statusfile.close()	
			offset = sock.send(mess)

			if (offset < lengthMess):
				logger.error(u"ОШИБКА. Данные отправлены не полностью")

			answer = sock.recv(1) 
			if int(answer.encode("hex"), 16) == 0x6:
				logger.debug(u"answer is correct")							
			else:
			 	logger.error(u"ОШИБКА.answer is incorrect")		
			 	statusfile = open(status,'w')	 	
				statusfile.write('Answer is incorrect')
				statusfile.close()	
			sock.close()		
		statusfile = open(status,'w')
		statusfile.write('Download complete')
		logger.info(u"Загрузка завершена")	
		statusfile.close()


