# -*- coding: utf8 -*-
'''
Created on 21.09.2012

@author: kov
'''

from paygate import PayGate
from plugins_base import BasePlugin, Queue, ThriftBinaryClient
from decimal import Decimal
from contextlib import closing

from logging import getLogger
logger = getLogger('su.artix.aqspy')

@Queue(name='artix.soldcards')
class SoldCardsPlugin(BasePlugin):

    client = ThriftBinaryClient(PayGate.Client)
    def __init__(self):
        self.failTimeout = 300
        super(SoldCardsPlugin, self).__init__()

    def _tryHosts(self, hosts):
        for addr, port in hosts:
            logger.info(u'Пробуем %s:%s' % (addr, port))
            try:
                self.socket.host = addr
                self.socket.port = int(port)
                with closing(self.socket):
                    self.socket.open()
                    yield self.client
            except Exception, e:
                logger.error(u'Ой: %s' % e)
                continue

    def handleMessage(self, message):
        logger.info(u'Получено сообщение: %s' % message)
        ok = False
        hosts = [ (message.content[u'host'], message.content[u'port']) ]
        if u'hosts' in message.content and str(message.content[u'hosts']) != "":
            additional_hosts = [ (h, int(p)) for h,p in [ i.split(':') for i in message.content[u'hosts'].split(',') ]]       
            hosts += additional_hosts      
        
        
        for client in self._tryHosts(hosts):
            clientInfo = PayGate.TClientInfo(
                                             terminalId = int(message.content[u'terminalId']),
                                             shiftNumber = int(message.content[u'shiftNumber']), 
                                             checkNumber = int(message.content[u'checkNumber']),
                                             userCode = str(message.content[u'userCode']),
                                             cardId = str(message.content[u'cardId']),
                                             notAddToWhiteList = bool(message.content[u'notAddToWhiteList'])
                                             )
            
            client.addCardToWhiteList(clientInfo)
            logger.info(u'Метод выполнен!')
            ok = True
            break

        if not ok:
            raise Exception(u'Сообщение не обработано: %s' % message.content)
