# -*- coding: utf-8 -*-

import sys
import optparse
from qpid.messaging import Connection, MessagingError

def printPayment(paymentId, accountNum, amout):
    print str(paymentId).rjust(19, ' '), accountNum, amout

def viewMessages(broker, address):

    connection = Connection(broker)
    try:
        connection.open()
        session = connection.session()
        receiver = session.receiver('%s; {create: always}' % (address))
        countMessage = 0
        if address == 'artix.paygate':
            printPayment("PAYMENTID", "ACCOUNTNUMBER", "AMOUT")

        while True:
            message = receiver.fetch(0)
            if address == 'artix.paygate':
                paymentId = message.content['paymentId'] if 'paymentId' in message.content else ""
                amount = message.content['amount'] if 'amount' in message.content else ""
                accountNumber = ""
                if 'account' in message.content and 'accountNumber' in message.content['account']:
                    accountNumber = message.content['account']['accountNumber']
                printPayment(paymentId, accountNumber, amount)
            else:
                print message.content
                print ""

            countMessage += 1
    except MessagingError, m:
        pass
    finally:
        connection.close()
        print "The number of messages: %s" % countMessage

def main(argv):

    parser = optparse.OptionParser()
    parser.add_option("-b", "--broker", help="<localhost>:<port>", default = 'localhost:5672')
    parser.add_option("-q", "--queue", help="name of queue", default = 'artix.paygate') 
    (options, args) = parser.parse_args(argv)

    viewMessages(options.broker, options.queue)

if __name__ == '__main__':
    main(sys.argv[1:])